Index: fedd/abac-src/rtml/doc/edu/stanford/rt/credential/CredentialDomain.html
===================================================================
--- fedd/abac-src/rtml/doc/edu/stanford/rt/credential/CredentialDomain.html	(revision 8780cbecc6db2bdc2b9ef31eec6e5209ad3bff15)
+++ fedd/abac-src/rtml/doc/edu/stanford/rt/credential/CredentialDomain.html	(revision 8780cbecc6db2bdc2b9ef31eec6e5209ad3bff15)
@@ -0,0 +1,654 @@
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN""http://www.w3.org/TR/REC-html40/loose.dtd">
+<!--NewPage-->
+<HTML>
+<HEAD>
+<!-- Generated by javadoc on Wed Oct 02 14:27:56 PDT 2002 -->
+<TITLE>
+CredentialDomain
+</TITLE>
+<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">
+</HEAD>
+<SCRIPT>
+function asd()
+{
+parent.document.title="CredentialDomain";
+}
+</SCRIPT>
+<BODY BGCOLOR="white" onload="asd();">
+
+<!-- ========== START OF NAVBAR ========== -->
+<A NAME="navbar_top"><!-- --></A>
+<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0">
+<TR>
+<TD COLSPAN=3 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
+<A NAME="navbar_top_firstrow"><!-- --></A>
+<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3">
+  <TR ALIGN="center" VALIGN="top">
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/CredentialDomain.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
+  </TR>
+</TABLE>
+</TD>
+<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
+</EM>
+</TD>
+</TR>
+
+<TR>
+<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
+&nbsp;<A HREF="../../../../edu/stanford/rt/credential/ApplicationDomain.html"><B>PREV CLASS</B></A>&nbsp;
+&nbsp;<A HREF="../../../../edu/stanford/rt/credential/CredentialStore.html"><B>NEXT CLASS</B></A></FONT></TD>
+<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
+  <A HREF="../../../../index.html" TARGET="_top"><B>FRAMES</B></A>  &nbsp;
+&nbsp;<A HREF="CredentialDomain.html" TARGET="_top"><B>NO FRAMES</B></A>  &nbsp;
+&nbsp;
+<SCRIPT>
+  <!--
+  if(window==top) {
+    document.writeln('<A HREF="../../../../allclasses-noframe.html" TARGET=""><B>All Classes</B></A>');
+  }
+  //-->
+</SCRIPT>
+<NOSCRIPT>
+<A HREF="../../../../allclasses-noframe.html" TARGET=""><B>All Classes</B></A>
+</NOSCRIPT>
+</FONT></TD>
+</TR>
+<TR>
+<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
+  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
+<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
+DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
+</TR>
+</TABLE>
+<!-- =========== END OF NAVBAR =========== -->
+
+<HR>
+<!-- ======== START OF CLASS DATA ======== -->
+<H2>
+<FONT SIZE="-1">
+edu.stanford.rt.credential</FONT>
+<BR>
+Class  CredentialDomain</H2>
+<PRE>
+java.lang.Object
+  |
+  +--<A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">edu.stanford.rt.credential.DomainSpecification</A>
+        |
+        +--<B>edu.stanford.rt.credential.CredentialDomain</B>
+</PRE>
+<HR>
+<DL>
+<DT>public class <B>CredentialDomain</B><DT>extends <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></DL>
+
+<P>
+<DL>
+<DT><B>Author:</B><DD>Ninghui Li, Sandra Qiu<br>
+
+ Implementation of <code>Credential</code> element.  Only one CredentialDomain object is associated with each Credential 
+ object.</DD>
+</DD>
+</DL>
+<HR>
+
+<P>
+<!-- ======== NESTED CLASS SUMMARY ======== -->
+
+
+<!-- =========== FIELD SUMMARY =========== -->
+
+<A NAME="field_summary"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
+<TD COLSPAN=2><FONT SIZE="+2">
+<B>Field Summary</B></FONT></TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>private &nbsp;org.w3c.dom.Element</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#credentialElement">credentialElement</A></B></CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the XML Element of the associated Credential.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>private &nbsp;<A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#issuer">issuer</A></B></CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Issuer of the associated Credential.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>private &nbsp;java.util.HashMap</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#principals">principals</A></B></CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maps String (principal shortName) to Principal object</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>private &nbsp;java.util.ArrayList</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#roleDefinitions">roleDefinitions</A></B></CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;list of role defined in this credential.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>private &nbsp;<A HREF="../../../../edu/stanford/rt/credential/ValidityTime.html">ValidityTime</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#validityTime">validityTime</A></B></CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;validity time of the associated Credential.</TD>
+</TR>
+</TABLE>
+&nbsp;<A NAME="fields_inherited_from_class_edu.stanford.rt.credential.DomainSpecification"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
+<TD><B>Fields inherited from class edu.stanford.rt.credential.<A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></B></TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD><CODE></CODE></TD>
+</TR>
+</TABLE>
+&nbsp;
+<!-- ======== CONSTRUCTOR SUMMARY ======== -->
+
+<A NAME="constructor_summary"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
+<TD COLSPAN=2><FONT SIZE="+2">
+<B>Constructor Summary</B></FONT></TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#CredentialDomain(org.w3c.dom.Element, edu.stanford.rt.credential.RTContext)">CredentialDomain</A></B>(org.w3c.dom.Element&nbsp;credentialElement,
+                 <A HREF="../../../../edu/stanford/rt/credential/RTContext.html">RTContext</A>&nbsp;rtContext)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructor for CredentialDomain.</TD>
+</TR>
+</TABLE>
+&nbsp;
+<!-- ========== METHOD SUMMARY =========== -->
+
+<A NAME="method_summary"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
+<TD COLSPAN=2><FONT SIZE="+2">
+<B>Method Summary</B></FONT></TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;void</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#addPrincipal(java.lang.String, edu.stanford.rt.credential.Principal)">addPrincipal</A></B>(java.lang.String&nbsp;shortName,
+             <A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A>&nbsp;principal)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method addPrincipal.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;void</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#addRoleDefinition(edu.stanford.rt.credential.RoleDefinition)">addRoleDefinition</A></B>(<A HREF="../../../../edu/stanford/rt/credential/RoleDefinition.html">RoleDefinition</A>&nbsp;roleDefinition)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Add a new role definition.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;<A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#getIssuer()">getIssuer</A></B>()</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the issuer.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;<A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#getPrincipal(java.lang.String)">getPrincipal</A></B>(java.lang.String&nbsp;shortName)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method getPrincipal.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;<A HREF="../../../../edu/stanford/rt/credential/ValidityTime.html">ValidityTime</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#getValidityTime()">getValidityTime</A></B>()</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the validityTime.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;<A HREF="../../../../edu/stanford/rt/credential/RoleDeclaration.html">RoleDeclaration</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#lookupRoleDeclaration(java.lang.String)">lookupRoleDeclaration</A></B>(java.lang.String&nbsp;roleName)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method lookupRoleDeclaration.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;<A HREF="../../../../edu/stanford/rt/datatype/DataType.html">DataType</A></CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#lookupType(java.lang.String)">lookupType</A></B>(java.lang.String&nbsp;typeName)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method lookupType.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;java.util.Iterator</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#roleDefinitionIterator()">roleDefinitionIterator</A></B>()</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method roleDefinitionIterator.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;void</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#setHashID(edu.stanford.rt.credential.HashID)">setHashID</A></B>(<A HREF="../../../../edu/stanford/rt/credential/HashID.html">HashID</A>&nbsp;hashID)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Sets the hashID.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;void</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#setIssuer(edu.stanford.rt.credential.Principal)">setIssuer</A></B>(<A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A>&nbsp;issuer)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method setIssuer.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;void</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#setValidityTime(edu.stanford.rt.credential.ValidityTime)">setValidityTime</A></B>(<A HREF="../../../../edu/stanford/rt/credential/ValidityTime.html">ValidityTime</A>&nbsp;validityTime)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method setValidityTime.</TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
+<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
+<TD><CODE><B><A HREF="../../../../edu/stanford/rt/credential/CredentialDomain.html#toString(java.lang.String)">toString</A></B>(java.lang.String&nbsp;indent)</CODE>
+
+<BR>
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Method toString.</TD>
+</TR>
+</TABLE>
+&nbsp;<A NAME="methods_inherited_from_class_edu.stanford.rt.credential.DomainSpecification"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
+<TD><B>Methods inherited from class edu.stanford.rt.credential.<A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></B></TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#addRole(edu.stanford.rt.credential.RoleDeclaration)">addRole</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#addType(edu.stanford.rt.datatype.DataType)">addType</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#addType(java.lang.String)">addType</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#getContext()">getContext</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#getHashID()">getHashID</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#getImportedDomains()">getImportedDomains</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#getPrincipalType()">getPrincipalType</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#getRoleDeclarations()">getRoleDeclarations</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#getTypeDeclarations()">getTypeDeclarations</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#importDomain(java.lang.String, edu.stanford.rt.credential.ApplicationDomain)">importDomain</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#isComplete()">isComplete</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#lookupImportedDomain(java.lang.String)">lookupImportedDomain</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#lookupRoleDeclaration(java.lang.String, java.lang.String)">lookupRoleDeclaration</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#lookupType(java.lang.String, java.lang.String)">lookupType</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#setComplete()">setComplete</A>, <A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#setPrincipalType(edu.stanford.rt.datatype.SimpleType)">setPrincipalType</A></CODE></TD>
+</TR>
+</TABLE>
+&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
+<TD><B>Methods inherited from class java.lang.Object</B></TD>
+</TR>
+<TR BGCOLOR="white" CLASS="TableRowColor">
+<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
+</TR>
+</TABLE>
+&nbsp;
+<P>
+
+<!-- ============ FIELD DETAIL =========== -->
+
+<A NAME="field_detail"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
+<TD COLSPAN=1><FONT SIZE="+2">
+<B>Field Detail</B></FONT></TD>
+</TR>
+</TABLE>
+
+<A NAME="issuer"><!-- --></A><H3>
+issuer</H3>
+<PRE>
+private <A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A> <B>issuer</B></PRE>
+<DL>
+<DD>Issuer of the associated Credential.
+<P>
+<DL>
+</DL>
+</DL>
+<HR>
+
+<A NAME="validityTime"><!-- --></A><H3>
+validityTime</H3>
+<PRE>
+private <A HREF="../../../../edu/stanford/rt/credential/ValidityTime.html">ValidityTime</A> <B>validityTime</B></PRE>
+<DL>
+<DD>validity time of the associated Credential.
+<P>
+<DL>
+</DL>
+</DL>
+<HR>
+
+<A NAME="principals"><!-- --></A><H3>
+principals</H3>
+<PRE>
+private java.util.HashMap <B>principals</B></PRE>
+<DL>
+<DD>maps String (principal shortName) to Principal object
+<P>
+<DL>
+</DL>
+</DL>
+<HR>
+
+<A NAME="roleDefinitions"><!-- --></A><H3>
+roleDefinitions</H3>
+<PRE>
+private java.util.ArrayList <B>roleDefinitions</B></PRE>
+<DL>
+<DD>list of role defined in this credential.
+<P>
+<DL>
+</DL>
+</DL>
+<HR>
+
+<A NAME="credentialElement"><!-- --></A><H3>
+credentialElement</H3>
+<PRE>
+private org.w3c.dom.Element <B>credentialElement</B></PRE>
+<DL>
+<DD>the XML Element of the associated Credential.
+<P>
+<DL>
+</DL>
+</DL>
+
+<!-- ========= CONSTRUCTOR DETAIL ======== -->
+
+<A NAME="constructor_detail"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
+<TD COLSPAN=1><FONT SIZE="+2">
+<B>Constructor Detail</B></FONT></TD>
+</TR>
+</TABLE>
+
+<A NAME="CredentialDomain(org.w3c.dom.Element, edu.stanford.rt.credential.RTContext)"><!-- --></A><H3>
+CredentialDomain</H3>
+<PRE>
+public <B>CredentialDomain</B>(org.w3c.dom.Element&nbsp;credentialElement,
+                        <A HREF="../../../../edu/stanford/rt/credential/RTContext.html">RTContext</A>&nbsp;rtContext)
+                 throws <A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></PRE>
+<DL>
+<DD>Constructor for CredentialDomain.
+<P>
+</DL>
+
+<!-- ============ METHOD DETAIL ========== -->
+
+<A NAME="method_detail"><!-- --></A>
+<TABLE BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
+<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
+<TD COLSPAN=1><FONT SIZE="+2">
+<B>Method Detail</B></FONT></TD>
+</TR>
+</TABLE>
+
+<A NAME="addPrincipal(java.lang.String, edu.stanford.rt.credential.Principal)"><!-- --></A><H3>
+addPrincipal</H3>
+<PRE>
+public void <B>addPrincipal</B>(java.lang.String&nbsp;shortName,
+                         <A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A>&nbsp;principal)
+                  throws <A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></PRE>
+<DL>
+<DD>Method addPrincipal.
+<P>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>shortName</CODE> - <DD><CODE>principal</CODE> - 
+<DT><B>Throws:</B>
+<DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></CODE></DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="getPrincipal(java.lang.String)"><!-- --></A><H3>
+getPrincipal</H3>
+<PRE>
+public <A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A> <B>getPrincipal</B>(java.lang.String&nbsp;shortName)</PRE>
+<DL>
+<DD>Method getPrincipal.
+<P>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>shortName</CODE> - 
+<DT><B>Returns:</B><DD>Principal
+  returns null if cannot find one.</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="setIssuer(edu.stanford.rt.credential.Principal)"><!-- --></A><H3>
+setIssuer</H3>
+<PRE>
+public void <B>setIssuer</B>(<A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A>&nbsp;issuer)</PRE>
+<DL>
+<DD>Method setIssuer.
+<P>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>issuer</CODE> - </DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="getIssuer()"><!-- --></A><H3>
+getIssuer</H3>
+<PRE>
+public <A HREF="../../../../edu/stanford/rt/credential/Principal.html">Principal</A> <B>getIssuer</B>()</PRE>
+<DL>
+<DD>Returns the issuer.
+<P>
+<DD><DL>
+
+<DT><B>Returns:</B><DD>Principal</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="getValidityTime()"><!-- --></A><H3>
+getValidityTime</H3>
+<PRE>
+public <A HREF="../../../../edu/stanford/rt/credential/ValidityTime.html">ValidityTime</A> <B>getValidityTime</B>()</PRE>
+<DL>
+<DD>Returns the validityTime.
+<P>
+<DD><DL>
+
+<DT><B>Returns:</B><DD>ValidityTime</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="setValidityTime(edu.stanford.rt.credential.ValidityTime)"><!-- --></A><H3>
+setValidityTime</H3>
+<PRE>
+public void <B>setValidityTime</B>(<A HREF="../../../../edu/stanford/rt/credential/ValidityTime.html">ValidityTime</A>&nbsp;validityTime)</PRE>
+<DL>
+<DD>Method setValidityTime.
+<P>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>validityTime</CODE> - </DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="toString(java.lang.String)"><!-- --></A><H3>
+toString</H3>
+<PRE>
+public java.lang.String <B>toString</B>(java.lang.String&nbsp;indent)</PRE>
+<DL>
+<DD>Method toString.
+<P>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>indent</CODE> - 
+<DT><B>Returns:</B><DD>String</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="setHashID(edu.stanford.rt.credential.HashID)"><!-- --></A><H3>
+setHashID</H3>
+<PRE>
+public void <B>setHashID</B>(<A HREF="../../../../edu/stanford/rt/credential/HashID.html">HashID</A>&nbsp;hashID)
+               throws <A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></PRE>
+<DL>
+<DD><B>Description copied from class: <CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></CODE></B></DD>
+<DD>Sets the hashID.
+<P>
+<DD><DL>
+<DT><B>Overrides:</B><DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#setHashID(edu.stanford.rt.credential.HashID)">setHashID</A></CODE> in class <CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></CODE></DL>
+</DD>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>hashID</CODE> - The hashID to set
+<DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></CODE></DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="roleDefinitionIterator()"><!-- --></A><H3>
+roleDefinitionIterator</H3>
+<PRE>
+public java.util.Iterator <B>roleDefinitionIterator</B>()</PRE>
+<DL>
+<DD>Method roleDefinitionIterator.
+<P>
+<DD><DL>
+
+<DT><B>Returns:</B><DD>Iterator</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="addRoleDefinition(edu.stanford.rt.credential.RoleDefinition)"><!-- --></A><H3>
+addRoleDefinition</H3>
+<PRE>
+public void <B>addRoleDefinition</B>(<A HREF="../../../../edu/stanford/rt/credential/RoleDefinition.html">RoleDefinition</A>&nbsp;roleDefinition)</PRE>
+<DL>
+<DD>Add a new role definition.
+<P>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>roleDefinition</CODE> - The roleDefinition to set</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="lookupType(java.lang.String)"><!-- --></A><H3>
+lookupType</H3>
+<PRE>
+public <A HREF="../../../../edu/stanford/rt/datatype/DataType.html">DataType</A> <B>lookupType</B>(java.lang.String&nbsp;typeName)
+                    throws <A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></PRE>
+<DL>
+<DD>Method lookupType.
+      Look up the DataType declaration by given typeName in the current domain.
+  if cannot find one then look it up in system domain.
+<P>
+<DD><DL>
+<DT><B>Overrides:</B><DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#lookupType(java.lang.String)">lookupType</A></CODE> in class <CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></CODE></DL>
+</DD>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>typeName</CODE> - 
+<DT><B>Returns:</B><DD>DataType
+<DT><B>Throws:</B>
+<DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></CODE> - if cannot find a DataType declaration by the given name.</DL>
+</DD>
+</DL>
+<HR>
+
+<A NAME="lookupRoleDeclaration(java.lang.String)"><!-- --></A><H3>
+lookupRoleDeclaration</H3>
+<PRE>
+public <A HREF="../../../../edu/stanford/rt/credential/RoleDeclaration.html">RoleDeclaration</A> <B>lookupRoleDeclaration</B>(java.lang.String&nbsp;roleName)
+                                      throws <A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></PRE>
+<DL>
+<DD>Method lookupRoleDeclaration.
+      Look up the role declaration by given roleName in the current domain.
+  If cannot find one then look it up in system domain.
+<P>
+<DD><DL>
+<DT><B>Overrides:</B><DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html#lookupRoleDeclaration(java.lang.String)">lookupRoleDeclaration</A></CODE> in class <CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecification.html">DomainSpecification</A></CODE></DL>
+</DD>
+<DD><DL>
+<DT><B>Parameters:</B><DD><CODE>roleName</CODE> - 
+<DT><B>Returns:</B><DD>RoleDeclaration
+<DT><B>Throws:</B>
+<DD><CODE><A HREF="../../../../edu/stanford/rt/credential/DomainSpecException.html">DomainSpecException</A></CODE> - if cannot find one.</DL>
+</DD>
+</DL>
+<!-- ========= END OF CLASS DATA ========= -->
+<HR>
+
+<!-- ========== START OF NAVBAR ========== -->
+<A NAME="navbar_bottom"><!-- --></A>
+<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0">
+<TR>
+<TD COLSPAN=3 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
+<A NAME="navbar_bottom_firstrow"><!-- --></A>
+<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3">
+  <TR ALIGN="center" VALIGN="top">
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/CredentialDomain.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
+  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
+  </TR>
+</TABLE>
+</TD>
+<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
+</EM>
+</TD>
+</TR>
+
+<TR>
+<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
+&nbsp;<A HREF="../../../../edu/stanford/rt/credential/ApplicationDomain.html"><B>PREV CLASS</B></A>&nbsp;
+&nbsp;<A HREF="../../../../edu/stanford/rt/credential/CredentialStore.html"><B>NEXT CLASS</B></A></FONT></TD>
+<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
+  <A HREF="../../../../index.html" TARGET="_top"><B>FRAMES</B></A>  &nbsp;
+&nbsp;<A HREF="CredentialDomain.html" TARGET="_top"><B>NO FRAMES</B></A>  &nbsp;
+&nbsp;
+<SCRIPT>
+  <!--
+  if(window==top) {
+    document.writeln('<A HREF="../../../../allclasses-noframe.html" TARGET=""><B>All Classes</B></A>');
+  }
+  //-->
+</SCRIPT>
+<NOSCRIPT>
+<A HREF="../../../../allclasses-noframe.html" TARGET=""><B>All Classes</B></A>
+</NOSCRIPT>
+</FONT></TD>
+</TR>
+<TR>
+<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
+  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
+<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
+DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
+</TR>
+</TABLE>
+<!-- =========== END OF NAVBAR =========== -->
+
+<HR>
+
+</BODY>
+</HTML>